﻿using ProjectCleaningCar.Entities;

namespace ProjectCleaningCar.Drawning;

/// <summary>
/// Расширение для класса EntityTruck
/// </summary>
public static class ExtentionDrawningTruck
{
    /// <summary>
    /// Разделитель для записи информации по объекту в файл
    /// </summary>
    private static readonly string _separatorForObject = ":";

    public static DrawningTruck? CreateDrawningCar(this string info)
    {
        string[] strs = info.Split(_separatorForObject);
        EntityTruck? truck = EntityCleaningCar.CreateEntityCleaningCar(strs);
        if (truck != null)
        {
            return new DrawningCleaningCar((EntityCleaningCar)truck);
        }
        truck = EntityTruck.CreateEntityCar(strs);
        if (truck != null)
        {
            return new DrawningTruck(truck);
        }
        return null;
    }

    /// <summary>
    /// Получение данных для сохранения в файл
    /// </summary>
    /// <param name="drawningCar"></param>
    /// <returns></returns>
    public static string GetDataForSave(this DrawningTruck drawningTruck)
    {
        string[]? array = drawningTruck?.EntityTruck?.GetStringRepresentation();
        if (array == null)
        {
            return string.Empty;
        }
        return string.Join(_separatorForObject, array);
    }

}
