﻿namespace ProjectCleaningCar.MovementStrategy;
/// <summary>
/// Стратегия перемещения объекта к границе экрана
/// </summary>
public class MoveToBorder : AbstractStrategy
{
    protected override bool IsTargetDestinaion()
    {
        ObjectParameters? objParams = GetObjectParameters;
        if (objParams == null)
        {
            return false;
        }
        return objParams.RightBorder + GetStep() >= FieldWidth && objParams.DownBorder + GetStep() >= FieldHeight;
    }

    protected override void MoveToTarget()
    {
        ObjectParameters? objParams = GetObjectParameters;
        if (objParams == null)
        {
            return;
        }
        int diffX = objParams.RightBorder;
        if (Math.Abs(diffX) > GetStep())
        {
            if (diffX < 0)
            {
                MoveLeft();
            }
            else
            {
                MoveRight();
            }
        }
        int diffY = objParams.DownBorder;
        if (Math.Abs(diffY) > GetStep())
        {
            if (diffY < 0)
            {
                MoveUp();
            }
            else
            {
                MoveDown();
            }
        }
    }
}
